-- By Ashnal
-- This is my own take on encore switching
-- Has separate turn on and turn off probabiulities, dont use at the same time as hm_encore

if au_encorerotate == nil then rawset (_G, "au_encorerotate", true) else return end 

local cv_encorerotate = CV_RegisterVar({
	name = "au_encorerotate",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local encorechance = CV_RegisterVar({
	name = "au_encorechance",
	defaultvalue = "25",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 0, MAX = 100}
})

local encorerevertchance = CV_RegisterVar({
	name = "au_encorerevertchance",
	defaultvalue = "75",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 0, MAX = 100}
})

local doencoreswitch
addHook("MapLoad", do
	doencoreswitch = true
end)

addHook("NetVars", function(net)
	doencoreswitch = net($) -- Necesary to ensure random doesnt get out of sync
end)

local function doSwitch()
	doencoreswitch = false
	if CV_FindVar("kartencore").value then
		if P_RandomRange(0, 100) <= encorerevertchance.value then
			COM_BufInsertText(server, "kartencore off")
		end
	else
		if P_RandomRange(0, 100) <= encorechance.value then
			COM_BufInsertText(server, "kartencore on")
		end
	end
end

addHook("IntermissionThinker", do
	if cv_encorerotate.value and doencoreswitch then
		doSwitch()
	end
end)

-- hm_intermission support
addHook("ThinkFrame", do
	if hm_intermissioncalc and hm_intermissioncalc() and cv_encorerotate.value and doencoreswitch then
		doSwitch()
	end
end)