-- By Ashnal
-- If set on and your spark is charged higher than blue when you bump, sets it to blue 
-- Load order agnostic

if au_bumpsparknerf == nil then rawset (_G, "au_bumpsparknerf", true) else return end

local cv_bumpsparknerf = CV_RegisterVar({
	name = "au_bumpsparknerf",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local MFE_JUSTBOUNCEDWALL = MFE_JUSTBOUNCEDWALL
local pmo, pks
addHook("ThinkFrame", do
	if not (cv_bumpsparknerf.value and kmp_bumpspark and kmp_bumpspark.value) then return end
	for p in players.iterate do
		pmo = p.mo
		if pmo and pmo.eflags & MFE_JUSTBOUNCEDWALL and pmo.k_saveddriftcharge then -- Fuck this ony gets set AFTER the lua hook for MobjThinker, so we have to use a thinkframe
			pks = p.kartstuff
			if pks[k_driftcharge] then -- kmp is loaded before us, and already set this
				pks[k_driftcharge] = min($, K_GetKartDriftSparkValue(p))
			else -- kmp loaded after us, and hasn't changed it
				pmo.k_saveddriftcharge = min($, K_GetKartDriftSparkValue(p))
			end
		end
	end	
end)