-- Ashnal's Lua implementation of https://git.do.srb2.org/KartKrew/Kart-Public/-/commit/17d45fc790bee442b6c4df24ff725589c90a4628
-- Thanks Lat!
if au_mobjscalefixscript == nil then rawset(_G, "au_mobjscalefixscript", true) else return end

-- On the very first think, recalc the Z to the fixed value and set it
local MFE_UNDERWATER = MFE_UNDERWATER
local mobjflip
local function fixmomz(mo)
	if not mo.mobjscalefix then
		if mo.momz then
			mobjflip = P_MobjFlip(mo)
			mo.momz = (30*mapobjectscale + (mo.target.momz*mobjflip))*mobjflip
			if mo.eflags & MFE_UNDERWATER then
				mo.momz = (117 * mo.momz) / 200
			end
		end
		mo.mobjscalefix = true
	end
end

addHook("MobjThinker", fixmomz, MT_SSMINE_SHIELD) -- the enum in hardcode is swapped with SSMINE in dehacked.c, so to properly hook SSMINE we need to specify SSMINE_SHIELD
addHook("MobjThinker", fixmomz, MT_EGGMANITEM)
addHook("MobjThinker", fixmomz, MT_BANANA)
addHook("MobjThinker", fixmomz, MT_SINK)